Index: uspace/app/sbi/src/run_expr.h
===================================================================
--- uspace/app/sbi/src/run_expr.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/run_expr.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef RUN_EXPR_H_
+#define RUN_EXPR_H_
+
+#include "mytypes.h"
+
+void run_expr(run_t *run, stree_expr_t *expr, rdata_item_t **res);
+
+void run_new_csi_inst(run_t *run, stree_csi_t *csi, rdata_item_t **res);
+bool_t run_item_boolean_value(run_t *run, rdata_item_t *item);
+
+
+#endif
Index: uspace/app/sbi/src/run_t.h
===================================================================
--- uspace/app/sbi/src/run_t.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/run_t.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,115 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef RUN_T_H_
+#define RUN_T_H_
+
+#include "intmap_t.h"
+#include "list_t.h"
+
+/** Block activation record
+ *
+ * One block AR is created for each block that we enter. A variable declaration
+ * statement inserts the variable here. Upon exiting the block we pop from the
+ * stack, thus all the variables declared in that block are forgotten.
+ */
+typedef struct run_block_ar {
+	/** Variables in this block */
+	intmap_t vars; /* of rdata_var_t */
+} run_block_ar_t;
+
+
+/** Procedure activation record
+ *
+ * A procedure can be a member function, a named property or an indexed
+ * property. A procedure activation record is created whenever a procedure
+ * is invoked.
+ */
+typedef struct run_proc_ar {
+	/** Object on which the procedure is being invoked or @c NULL. */
+	struct rdata_var *obj;
+
+	/** Procedure being invoked */
+	struct stree_proc *proc;
+
+	/** Block activation records */
+	list_t block_ar; /* of run_block_ar_t */
+
+	/** Procedure return value or @c NULL if not set. */
+	struct rdata_item *retval;
+} run_proc_ar_t;
+
+/** Bailout mode
+ *
+ * Determines whether control is bailing out of a statement, function, etc.
+ */
+typedef enum {
+	/** Normal execution */
+	bm_none,
+
+	/** Break from statement */
+	bm_stat,
+
+	/** Return from procedure */
+	bm_proc,
+
+	/** Exception */
+	bm_exc,
+
+	/** Unrecoverable runtime error */
+	bm_error
+} run_bailout_mode_t;
+
+/** Thread activation record
+ *
+ * We can walk the list of function ARs to get a function call backtrace.
+ */
+typedef struct run_thread_ar {
+	/** Function activation records */
+	list_t proc_ar; /* of run_proc_ar_t */
+
+	/** Bailout mode */
+	run_bailout_mode_t bo_mode;
+
+	/** Exception payload */
+	struct rdata_value *exc_payload;
+
+	/** @c b_true if a run-time error occured. */
+	bool_t error;
+} run_thread_ar_t;
+
+/** Runner state object */
+typedef struct run {
+	/** Code of the program being executed */
+	struct stree_program *program;
+
+	/** Thread-private state */
+	run_thread_ar_t *thread_ar;
+} run_t;
+
+#endif
Index: uspace/app/sbi/src/run_texpr.c
===================================================================
--- uspace/app/sbi/src/run_texpr.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/run_texpr.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,290 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file Evaluates type expressions. */
+
+#include <assert.h>
+#include <stdlib.h>
+#include "list.h"
+#include "mytypes.h"
+#include "strtab.h"
+#include "symbol.h"
+#include "tdata.h"
+
+#include "run_texpr.h"
+
+static void run_taccess(stree_program_t *prog, stree_csi_t *ctx,
+    stree_taccess_t *taccess, tdata_item_t **res);
+static void run_tindex(stree_program_t *prog, stree_csi_t *ctx,
+    stree_tindex_t *tindex, tdata_item_t **res);
+static void run_tliteral(stree_program_t *prog, stree_csi_t *ctx,
+    stree_tliteral_t *tliteral, tdata_item_t **res);
+static void run_tnameref(stree_program_t *prog, stree_csi_t *ctx,
+    stree_tnameref_t *tnameref, tdata_item_t **res);
+static void run_tapply(stree_program_t *prog, stree_csi_t *ctx,
+    stree_tapply_t *tapply, tdata_item_t **res);
+
+void run_texpr(stree_program_t *prog, stree_csi_t *ctx, stree_texpr_t *texpr,
+    tdata_item_t **res)
+{
+	switch (texpr->tc) {
+	case tc_taccess:
+		run_taccess(prog, ctx, texpr->u.taccess, res);
+		break;
+	case tc_tindex:
+		run_tindex(prog, ctx, texpr->u.tindex, res);
+		break;
+	case tc_tliteral:
+		run_tliteral(prog, ctx, texpr->u.tliteral, res);
+		break;
+	case tc_tnameref:
+		run_tnameref(prog, ctx, texpr->u.tnameref, res);
+		break;
+	case tc_tapply:
+		run_tapply(prog, ctx, texpr->u.tapply, res);
+		break;
+	}
+}
+
+static void run_taccess(stree_program_t *prog, stree_csi_t *ctx,
+    stree_taccess_t *taccess, tdata_item_t **res)
+{
+	stree_symbol_t *sym;
+	tdata_item_t *targ_i;
+	tdata_item_t *titem;
+	tdata_object_t *tobject;
+	stree_csi_t *base_csi;
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Evaluating type access operation.\n");
+#endif
+	/* Evaluate base type. */
+	run_texpr(prog, ctx, taccess->arg, &targ_i);
+
+	if (targ_i->tic == tic_ignore) {
+		*res = tdata_item_new(tic_ignore);
+		return;
+	}
+
+	if (targ_i->tic != tic_tobject) {
+		printf("Error: Using '.' with type which is not an object.\n");
+		*res = tdata_item_new(tic_ignore);
+		return;
+	}
+
+	/* Get base CSI. */
+	base_csi = targ_i->u.tobject->csi;
+
+	sym = symbol_lookup_in_csi(prog, base_csi, taccess->member_name);
+	if (sym == NULL) {
+		printf("Error: CSI '");
+		symbol_print_fqn(csi_to_symbol(base_csi));
+		printf("' has no member named '%s'.\n",
+		    strtab_get_str(taccess->member_name->sid));
+		*res = tdata_item_new(tic_ignore);
+		return;
+	}
+
+	if (sym->sc != sc_csi) {
+		printf("Error: Symbol '");
+		symbol_print_fqn(sym);
+		printf("' is not a CSI.\n");
+		*res = tdata_item_new(tic_ignore);
+		return;
+	}
+
+	/* Construct type item. */
+	titem = tdata_item_new(tic_tobject);
+	tobject = tdata_object_new();
+	titem->u.tobject = tobject;
+
+	tobject->static_ref = b_false;
+	tobject->csi = sym->u.csi;
+
+	*res = titem;
+}
+
+static void run_tindex(stree_program_t *prog, stree_csi_t *ctx,
+    stree_tindex_t *tindex, tdata_item_t **res)
+{
+	tdata_item_t *base_ti;
+	tdata_item_t *titem;
+	tdata_array_t *tarray;
+	stree_expr_t *arg_expr;
+	list_node_t *arg_node;
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Evaluating type index operation.\n");
+#endif
+	/* Evaluate base type. */
+	run_texpr(prog, ctx, tindex->base_type, &base_ti);
+
+	if (base_ti->tic == tic_ignore) {
+		*res = tdata_item_new(tic_ignore);
+		return;
+	}
+
+	/* Construct type item. */
+	titem = tdata_item_new(tic_tarray);
+	tarray = tdata_array_new();
+	titem->u.tarray = tarray;
+
+	tarray->base_ti = base_ti;
+	tarray->rank = tindex->n_args;
+
+	/* Copy extents. */
+	list_init(&tarray->extents);
+	arg_node = list_first(&tindex->args);
+
+	while (arg_node != NULL) {
+		arg_expr = list_node_data(arg_node, stree_expr_t *);
+		list_append(&tarray->extents, arg_expr);
+		arg_node = list_next(&tindex->args, arg_node);
+	}
+
+	*res = titem;
+}
+
+static void run_tliteral(stree_program_t *prog, stree_csi_t *ctx,
+    stree_tliteral_t *tliteral, tdata_item_t **res)
+{
+	tdata_item_t *titem;
+	tdata_primitive_t *tprimitive;
+	tprimitive_class_t tpc;
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Evaluating type literal.\n");
+#endif
+	(void) prog;
+	(void) ctx;
+	(void) tliteral;
+
+	switch (tliteral->tlc) {
+	case tlc_bool: tpc = tpc_bool; break;
+	case tlc_char: tpc = tpc_char; break;
+	case tlc_int: tpc = tpc_int; break;
+	case tlc_string: tpc = tpc_string; break;
+	case tlc_resource: tpc = tpc_resource; break;
+	}
+
+	/* Construct type item. */
+	titem = tdata_item_new(tic_tprimitive);
+	tprimitive = tdata_primitive_new(tpc);
+	titem->u.tprimitive = tprimitive;
+
+	*res = titem;
+}
+
+static void run_tnameref(stree_program_t *prog, stree_csi_t *ctx,
+    stree_tnameref_t *tnameref, tdata_item_t **res)
+{
+	stree_symbol_t *sym;
+	tdata_item_t *titem;
+	tdata_object_t *tobject;
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Evaluating type name reference.\n");
+#endif
+	sym = symbol_lookup_in_csi(prog, ctx, tnameref->name);
+	if (sym == NULL) {
+		printf("Error: Symbol '%s' not found.\n",
+		    strtab_get_str(tnameref->name->sid));
+		*res = tdata_item_new(tic_ignore);
+		return;
+	}
+
+	if (sym->sc != sc_csi) {
+		printf("Error: Symbol '");
+		symbol_print_fqn(sym);
+		printf("' is not a CSI.\n");
+		*res = tdata_item_new(tic_ignore);
+		return;
+	}
+
+	/* Construct type item. */
+	titem = tdata_item_new(tic_tobject);
+	tobject = tdata_object_new();
+	titem->u.tobject = tobject;
+
+	tobject->static_ref = b_false;
+	tobject->csi = sym->u.csi;
+
+	*res = titem;
+}
+
+static void run_tapply(stree_program_t *prog, stree_csi_t *ctx,
+    stree_tapply_t *tapply, tdata_item_t **res)
+{
+	tdata_item_t *base_ti;
+	tdata_item_t *arg_ti;
+	tdata_item_t *titem;
+	tdata_object_t *tobject;
+
+	list_node_t *arg_n;
+	stree_texpr_t *arg;
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Evaluating type apply operation.\n");
+#endif
+	/* Construct type item. */
+	titem = tdata_item_new(tic_tobject);
+	tobject = tdata_object_new();
+	titem->u.tobject = tobject;
+
+	/* Evaluate base (generic) type. */
+	run_texpr(prog, ctx, tapply->gtype, &base_ti);
+
+	if (base_ti->tic != tic_tobject) {
+		printf("Error: Base type of generic application is not "
+		    "a CSI.\n");
+		*res = tdata_item_new(tic_ignore);
+		return;
+	}
+
+	tobject->static_ref = b_false;
+	tobject->csi = base_ti->u.tobject->csi;
+	list_init(&tobject->targs);
+
+	/* Evaluate type arguments. */
+	arg_n = list_first(&tapply->targs);
+	while (arg_n != NULL) {
+		arg = list_node_data(arg_n, stree_texpr_t *);
+		run_texpr(prog, ctx, arg, &arg_ti);
+
+		if (arg_ti->tic == tic_ignore) {
+			*res = tdata_item_new(tic_ignore);
+			return;
+		}
+
+		list_append(&tobject->targs, arg_ti);
+
+		arg_n = list_next(&tapply->targs, arg_n);
+	}
+
+	*res = titem;
+}
Index: uspace/app/sbi/src/run_texpr.h
===================================================================
--- uspace/app/sbi/src/run_texpr.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/run_texpr.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,37 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef RUN_TEXPR_H_
+#define RUN_TEXPR_H_
+
+#include "mytypes.h"
+
+void run_texpr(stree_program_t *prog, stree_csi_t *ctx, stree_texpr_t *texpr,
+    tdata_item_t **res);
+
+#endif
Index: uspace/app/sbi/src/stree.c
===================================================================
--- uspace/app/sbi/src/stree.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/stree.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,674 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file Stree (syntax tree) intermediate representation. */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <assert.h>
+#include "list.h"
+#include "mytypes.h"
+
+#include "stree.h"
+
+stree_module_t *stree_module_new(void)
+{
+	stree_module_t *module;
+
+	module = calloc(1, sizeof(stree_module_t));
+	if (module == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	list_init(&module->members);
+	return module;
+}
+
+stree_modm_t *stree_modm_new(modm_class_t mc)
+{
+	stree_modm_t *modm;
+
+	modm = calloc(1, sizeof(stree_modm_t));
+	if (modm == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	modm->mc = mc;
+	return modm;
+}
+
+stree_csi_t *stree_csi_new(csi_class_t cc)
+{
+	stree_csi_t *csi;
+
+	csi = calloc(1, sizeof(stree_csi_t));
+	if (csi == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	csi->cc = cc;
+	csi->ancr_state = ws_unvisited;
+	csi->name = NULL;
+	csi->base_csi_ref = NULL;
+	list_init(&csi->members);
+	return csi;
+}
+
+stree_csimbr_t *stree_csimbr_new(csimbr_class_t cc)
+{
+	stree_csimbr_t *csimbr;
+
+	csimbr = calloc(1, sizeof(stree_csimbr_t));
+	if (csimbr == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	csimbr->cc = cc;
+	return csimbr;
+}
+
+stree_fun_t *stree_fun_new(void)
+{
+	stree_fun_t *fun;
+
+	fun = calloc(1, sizeof(stree_fun_t));
+	if (fun == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return fun;
+}
+
+stree_var_t *stree_var_new(void)
+{
+	stree_var_t *var;
+
+	var = calloc(1, sizeof(stree_var_t));
+	if (var == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return var;
+}
+
+stree_prop_t *stree_prop_new(void)
+{
+	stree_prop_t *prop;
+
+	prop = calloc(1, sizeof(stree_prop_t));
+	if (prop == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return prop;
+}
+
+stree_symbol_attr_t *stree_symbol_attr_new(symbol_attr_class_t sac)
+{
+	stree_symbol_attr_t *symbol_attr;
+
+	symbol_attr = calloc(1, sizeof(stree_symbol_attr_t));
+	if (symbol_attr == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	symbol_attr->sac = sac;
+	return symbol_attr;
+}
+
+stree_proc_t *stree_proc_new(void)
+{
+	stree_proc_t *proc;
+
+	proc = calloc(1, sizeof(stree_proc_t));
+	if (proc == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return proc;
+}
+
+stree_proc_arg_t *stree_proc_arg_new(void)
+{
+	stree_proc_arg_t *proc_arg;
+
+	proc_arg = calloc(1, sizeof(stree_proc_arg_t));
+	if (proc_arg == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return proc_arg;
+}
+
+stree_arg_attr_t *stree_arg_attr_new(arg_attr_class_t aac)
+{
+	stree_arg_attr_t *arg_attr;
+
+	arg_attr = calloc(1, sizeof(stree_arg_attr_t));
+	if (arg_attr == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	arg_attr->aac = aac;
+	return arg_attr;
+}
+
+stree_stat_t *stree_stat_new(stat_class_t sc)
+{
+	stree_stat_t *stat;
+
+	stat = calloc(1, sizeof(stree_stat_t));
+	if (stat == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	stat->sc = sc;
+	return stat;
+}
+
+stree_vdecl_t *stree_vdecl_new(void)
+{
+	stree_vdecl_t *vdecl_s;
+
+	vdecl_s = calloc(1, sizeof(stree_vdecl_t));
+	if (vdecl_s == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return vdecl_s;
+}
+
+stree_if_t *stree_if_new(void)
+{
+	stree_if_t *if_s;
+
+	if_s = calloc(1, sizeof(stree_if_t));
+	if (if_s == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return if_s;
+}
+
+stree_while_t *stree_while_new(void)
+{
+	stree_while_t *while_s;
+
+	while_s = calloc(1, sizeof(stree_while_t));
+	if (while_s == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return while_s;
+}
+
+stree_for_t *stree_for_new(void)
+{
+	stree_for_t *for_s;
+
+	for_s = calloc(1, sizeof(stree_for_t));
+	if (for_s == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return for_s;
+}
+
+stree_raise_t *stree_raise_new(void)
+{
+	stree_raise_t *raise_s;
+
+	raise_s = calloc(1, sizeof(stree_raise_t));
+	if (raise_s == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return raise_s;
+}
+
+stree_return_t *stree_return_new(void)
+{
+	stree_return_t *return_s;
+
+	return_s = calloc(1, sizeof(stree_return_t));
+	if (return_s == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return return_s;
+}
+
+stree_wef_t *stree_wef_new(void)
+{
+	stree_wef_t *wef_s;
+
+	wef_s = calloc(1, sizeof(stree_wef_t));
+	if (wef_s == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return wef_s;
+}
+
+stree_exps_t *stree_exps_new(void)
+{
+	stree_exps_t *exp_s;
+
+	exp_s = calloc(1, sizeof(stree_exps_t));
+	if (exp_s == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return exp_s;
+}
+
+stree_except_t *stree_except_new(void)
+{
+	stree_except_t *except_c;
+
+	except_c = calloc(1, sizeof(stree_except_t));
+	if (except_c == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return except_c;
+}
+
+stree_block_t *stree_block_new(void)
+{
+	stree_block_t *block;
+
+	block = calloc(1, sizeof(stree_block_t));
+	if (block == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return block;
+}
+
+stree_expr_t *stree_expr_new(expr_class_t ec)
+{
+	stree_expr_t *expr;
+
+	expr = calloc(1, sizeof(stree_expr_t));
+	if (expr == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	expr->ec = ec;
+	return expr;
+}
+
+stree_assign_t *stree_assign_new(assign_class_t ac)
+{
+	stree_assign_t *assign;
+
+	assign = calloc(1, sizeof(stree_assign_t));
+	if (assign == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	assign->ac = ac;
+	return assign;
+}
+
+stree_binop_t *stree_binop_new(binop_class_t bc)
+{
+	stree_binop_t *binop;
+
+	binop = calloc(1, sizeof(stree_binop_t));
+	if (binop == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	binop->bc = bc;
+	return binop;
+}
+
+stree_unop_t *stree_unop_new(unop_class_t uc)
+{
+	stree_unop_t *unop;
+
+	unop = calloc(1, sizeof(stree_unop_t));
+	if (unop == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	unop->uc = uc;
+	return unop;
+}
+
+stree_new_t *stree_new_new(void)
+{
+	stree_new_t *new_op;
+
+	new_op = calloc(1, sizeof(stree_new_t));
+	if (new_op == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return new_op;
+}
+
+stree_access_t *stree_access_new(void)
+{
+	stree_access_t *access;
+
+	access = calloc(1, sizeof(stree_access_t));
+	if (access == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return access;
+}
+
+stree_call_t *stree_call_new(void)
+{
+	stree_call_t *call;
+
+	call = calloc(1, sizeof(stree_call_t));
+	if (call == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return call;
+}
+
+stree_index_t *stree_index_new(void)
+{
+	stree_index_t *index;
+
+	index = calloc(1, sizeof(stree_index_t));
+	if (index == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return index;
+}
+
+stree_as_t *stree_as_new(void)
+{
+	stree_as_t *as_expr;
+
+	as_expr = calloc(1, sizeof(stree_as_t));
+	if (as_expr == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return as_expr;
+}
+
+stree_nameref_t *stree_nameref_new(void)
+{
+	stree_nameref_t *nameref;
+
+	nameref = calloc(1, sizeof(stree_nameref_t));
+	if (nameref == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return nameref;
+}
+
+stree_ident_t *stree_ident_new(void)
+{
+	stree_ident_t *ident;
+
+	ident = calloc(1, sizeof(stree_ident_t));
+	if (ident == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return ident;
+}
+
+stree_literal_t *stree_literal_new(literal_class_t ltc)
+{
+	stree_literal_t *literal;
+
+	literal = calloc(1, sizeof(stree_literal_t));
+	if (literal == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	literal->ltc = ltc;
+	return literal;
+}
+
+stree_self_ref_t *stree_self_ref_new(void)
+{
+	stree_self_ref_t *self_ref;
+
+	self_ref = calloc(1, sizeof(stree_self_ref_t));
+	if (self_ref == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return self_ref;
+}
+
+stree_texpr_t *stree_texpr_new(texpr_class_t tc)
+{
+	stree_texpr_t *texpr;
+
+	texpr = calloc(1, sizeof(stree_texpr_t));
+	if (texpr == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	texpr->tc = tc;
+	return texpr;
+}
+
+stree_taccess_t *stree_taccess_new(void)
+{
+	stree_taccess_t *taccess;
+
+	taccess = calloc(1, sizeof(stree_taccess_t));
+	if (taccess == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return taccess;
+}
+
+stree_tapply_t *stree_tapply_new(void)
+{
+	stree_tapply_t *tapply;
+
+	tapply = calloc(1, sizeof(stree_tapply_t));
+	if (tapply == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return tapply;
+}
+
+stree_tindex_t *stree_tindex_new(void)
+{
+	stree_tindex_t *tindex;
+
+	tindex = calloc(1, sizeof(stree_tindex_t));
+	if (tindex == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return tindex;
+}
+
+stree_tliteral_t *stree_tliteral_new(tliteral_class_t tlc)
+{
+	stree_tliteral_t *tliteral;
+
+	tliteral = calloc(1, sizeof(stree_tliteral_t));
+	if (tliteral == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	tliteral->tlc = tlc;
+	return tliteral;
+}
+
+stree_tnameref_t *stree_tnameref_new(void)
+{
+	stree_tnameref_t *tnameref;
+
+	tnameref = calloc(1, sizeof(stree_tnameref_t));
+	if (tnameref == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return tnameref;
+}
+
+stree_symbol_t *stree_symbol_new(symbol_class_t sc)
+{
+	stree_symbol_t *symbol;
+
+	symbol = calloc(1, sizeof(stree_symbol_t));
+	if (symbol == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	symbol->sc = sc;
+	return symbol;
+}
+
+stree_program_t *stree_program_new(void)
+{
+	stree_program_t *program;
+
+	program = calloc(1, sizeof(stree_program_t));
+	if (program == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return program;
+}
+
+/** Determine if @a symbol has attribute of class @a sac. */
+bool_t stree_symbol_has_attr(stree_symbol_t *symbol, symbol_attr_class_t sac)
+{
+	list_node_t *node;
+	stree_symbol_attr_t *attr;
+
+	node = list_first(&symbol->attr);
+	while (node != NULL) {
+		attr = list_node_data(node, stree_symbol_attr_t *);
+		if (attr->sac == sac)
+			return b_true;
+
+		node = list_next(&symbol->attr, node);
+	}
+
+	return b_false;
+}
+
+/** Determine if argument @a arg has attribute of class @a aac. */
+bool_t stree_arg_has_attr(stree_proc_arg_t *arg, arg_attr_class_t aac)
+{
+	list_node_t *node;
+	stree_arg_attr_t *attr;
+
+	node = list_first(&arg->attr);
+	while (node != NULL) {
+		attr = list_node_data(node, stree_arg_attr_t *);
+		if (attr->aac == aac)
+			return b_true;
+
+		node = list_next(&arg->attr, node);
+	}
+
+	return b_false;
+}
+
+/** Determine wheter @a a is derived (transitively) from @a b.
+ *
+ * @param a	Derived CSI.
+ * @param b	Base CSI.
+ * @return	@c b_true if @a a is equal to or directly or indirectly
+ *		derived from @a b.
+ */
+bool_t stree_is_csi_derived_from_csi(stree_csi_t *a, stree_csi_t *b)
+{
+	stree_csi_t *csi;
+
+	csi = a;
+	while (csi != NULL) {
+		if (csi == b)
+			return b_true;
+
+		csi = csi->base_csi;
+	}
+
+	/* We went all the way to the root and did not find b. */
+	return b_false;
+}
